/*
 * This file is auto-generated.  DO NOT MODIFY.
 */
package com.sunmi.pay.hardware.aidlv2.system;
// Declare any non-default types here with import statements

public interface BasicOptV2 extends android.os.IInterface
{
  /** Default implementation for BasicOptV2. */
  public static class Default implements com.sunmi.pay.hardware.aidlv2.system.BasicOptV2
  {
    /**
         * 获取系统参数
         * 功能>通过用户参数关键字，读取系统资源关键字的属性
         * @param key：用户参数关键字,含义如下：
         * <li>“SDKVer”-SDK版本查询</li>
         * <li>“HardwareVer”-设备硬件版本</li>
         * <li>“FirmwareVer”-设备固件版本</li>
         * <li>“SN”-获取机器SN号</li>
         * <li>“PN”-获取机器SN1(PN)渠道自定义SN号</li>
         * <li>“TUSN”-获取机器银联TUSN号</li>
         * <li>“DeviceCode”-获取设备型号</li>
         * <li>“DeviceModel”-获取机型</li>
         * @return 所查询的属性值
         */
    @Override public java.lang.String getSysParam(java.lang.String key) throws android.os.RemoteException
    {
      return null;
    }
    /**
         * 设置系统参数
         * 功能>写入资源窗口关键字的属性
         * @param key：用户参数关键字
         * @param value：关键字属性值
         * @return 0-成功,非0-错误码
         */
    @Override public int setSysParam(java.lang.String key, java.lang.String value) throws android.os.RemoteException
    {
      return 0;
    }
    /**
         * 蜂鸣器
         * 功能>控制设备上的蜂鸣器响
         * @param count 连续鸣响的次数(0~100)
         * @param freq  鸣响频率（单位:HZ）
         * @param duration 鸣响的时长（单位：ms）
         * @param interval 两次鸣响的时间间隔（单位：ms,0~10000）
         * @return 0-成功，非0-错误码
         */
    @Override public void buzzerOnDevice(int count, int freq, int duration, int interval) throws android.os.RemoteException
    {
    }
    /**
         * LED灯控制
         * 功能>设备上的LED灯状态
         * @param ledIndex: 设备上的LED索引，1~4；1-红，2-绿，3-黄，4-蓝
         * @param ledStatus：LED状态，1表示LED灭，0表示LED亮
         * @return 0-成功，非0-错误码
         */
    @Override public int ledStatusOnDevice(int ledIndex, int ledStatus) throws android.os.RemoteException
    {
      return 0;
    }
    /**
         * 设置屏幕独占
         * 功能>设置屏幕独占 禁用底部导航栏和SystemUI下拉框、保持屏幕高亮，不锁屏、禁用音量键
         * @param mode：设置屏幕独占的模式，1：设置屏幕独占，-1设置取消屏幕独占
         * @return 0-成功，非0-错误码
         */
    @Override public int setScreenMode(int mode) throws android.os.RemoteException
    {
      return 0;
    }
    /**
         * 获取随机数
         * 功能>获取随机数
         * @param randData：随机数
         * @param len：要获取的随机数长度
         * @return 0-成功，非0-错误码
         */
    @Override public int sysGetRandom(byte[] randData, int len) throws android.os.RemoteException
    {
      return 0;
    }
    /**
         * 扩展版LED灯控制
         * @param redStatus 红灯状态,0-亮，1-灭
         * @param greenStatus 绿灯状态,0-亮，1-灭
         * @param yellowStatus 黄灯状态,0-亮，1-灭
         * @param blueStatus 蓝灯状态,0-亮，1-灭
         * @return 0-成功，非0-错误码
         */
    @Override public int ledStatusOnDeviceEx(int redStatus, int greenStatus, int yellowStatus, int blueStatus) throws android.os.RemoteException
    {
      return 0;
    }
    /**
         * 设置状态栏下拉模式
         * @param mode 状态栏下拉模式，0-启用下拉，1-禁用下拉
         * @return 0-成功，非0-错误码
         */
    @Override public int setStatusBarDropDownMode(int mode) throws android.os.RemoteException
    {
      return 0;
    }
    /**
         * 设置导航栏可见性
         * @param visibility 导航栏可见性，0-隐藏，1-显示
         * @return 0-成功，非0-错误码
         */
    @Override public int setNavigationBarVisibility(int visibility) throws android.os.RemoteException
    {
      return 0;
    }
    /**
         * 设置隐藏导航栏图标
         * STATUS_BAR_DISABLE_HOME = 0x00200000;//隐藏home键
         * STATUS_BAR_DISABLE_BACK = 0x00400000;//隐藏返回键
         * STATUS_BAR_DISABLE_RECENT = 0x01000000;//隐藏recent键
         * @param mode：隐藏标志，STATUS_BAR_DISABLE_HOME | STATUS_BAR_DISABLE_BACK 可同时隐藏home键和返回键
         * @return 0-成功，非0-错误码
         */
    @Override public int setHideNavigationBarItems(int flag) throws android.os.RemoteException
    {
      return 0;
    }
    /**
         * 电源管理
         * @param mode 模式，1-休眠(不支持)，2-关机，3-重启
         * @return 0-成功，非0-错误码
         */
    @Override public int sysPowerManage(int mode) throws android.os.RemoteException
    {
      return 0;
    }
    @Override
    public android.os.IBinder asBinder() {
      return null;
    }
  }
  /** Local-side IPC implementation stub class. */
  public static abstract class Stub extends android.os.Binder implements com.sunmi.pay.hardware.aidlv2.system.BasicOptV2
  {
    private static final java.lang.String DESCRIPTOR = "com.sunmi.pay.hardware.aidlv2.system.BasicOptV2";
    /** Construct the stub at attach it to the interface. */
    public Stub()
    {
      this.attachInterface(this, DESCRIPTOR);
    }
    /**
     * Cast an IBinder object into an com.sunmi.pay.hardware.aidlv2.system.BasicOptV2 interface,
     * generating a proxy if needed.
     */
    public static com.sunmi.pay.hardware.aidlv2.system.BasicOptV2 asInterface(android.os.IBinder obj)
    {
      if ((obj==null)) {
        return null;
      }
      android.os.IInterface iin = obj.queryLocalInterface(DESCRIPTOR);
      if (((iin!=null)&&(iin instanceof com.sunmi.pay.hardware.aidlv2.system.BasicOptV2))) {
        return ((com.sunmi.pay.hardware.aidlv2.system.BasicOptV2)iin);
      }
      return new com.sunmi.pay.hardware.aidlv2.system.BasicOptV2.Stub.Proxy(obj);
    }
    @Override public android.os.IBinder asBinder()
    {
      return this;
    }
    @Override public boolean onTransact(int code, android.os.Parcel data, android.os.Parcel reply, int flags) throws android.os.RemoteException
    {
      java.lang.String descriptor = DESCRIPTOR;
      switch (code)
      {
        case INTERFACE_TRANSACTION:
        {
          reply.writeString(descriptor);
          return true;
        }
        case TRANSACTION_getSysParam:
        {
          data.enforceInterface(descriptor);
          java.lang.String _arg0;
          _arg0 = data.readString();
          java.lang.String _result = this.getSysParam(_arg0);
          reply.writeNoException();
          reply.writeString(_result);
          return true;
        }
        case TRANSACTION_setSysParam:
        {
          data.enforceInterface(descriptor);
          java.lang.String _arg0;
          _arg0 = data.readString();
          java.lang.String _arg1;
          _arg1 = data.readString();
          int _result = this.setSysParam(_arg0, _arg1);
          reply.writeNoException();
          reply.writeInt(_result);
          return true;
        }
        case TRANSACTION_buzzerOnDevice:
        {
          data.enforceInterface(descriptor);
          int _arg0;
          _arg0 = data.readInt();
          int _arg1;
          _arg1 = data.readInt();
          int _arg2;
          _arg2 = data.readInt();
          int _arg3;
          _arg3 = data.readInt();
          this.buzzerOnDevice(_arg0, _arg1, _arg2, _arg3);
          return true;
        }
        case TRANSACTION_ledStatusOnDevice:
        {
          data.enforceInterface(descriptor);
          int _arg0;
          _arg0 = data.readInt();
          int _arg1;
          _arg1 = data.readInt();
          int _result = this.ledStatusOnDevice(_arg0, _arg1);
          reply.writeNoException();
          reply.writeInt(_result);
          return true;
        }
        case TRANSACTION_setScreenMode:
        {
          data.enforceInterface(descriptor);
          int _arg0;
          _arg0 = data.readInt();
          int _result = this.setScreenMode(_arg0);
          reply.writeNoException();
          reply.writeInt(_result);
          return true;
        }
        case TRANSACTION_sysGetRandom:
        {
          data.enforceInterface(descriptor);
          byte[] _arg0;
          _arg0 = data.createByteArray();
          int _arg1;
          _arg1 = data.readInt();
          int _result = this.sysGetRandom(_arg0, _arg1);
          reply.writeNoException();
          reply.writeInt(_result);
          reply.writeByteArray(_arg0);
          return true;
        }
        case TRANSACTION_ledStatusOnDeviceEx:
        {
          data.enforceInterface(descriptor);
          int _arg0;
          _arg0 = data.readInt();
          int _arg1;
          _arg1 = data.readInt();
          int _arg2;
          _arg2 = data.readInt();
          int _arg3;
          _arg3 = data.readInt();
          int _result = this.ledStatusOnDeviceEx(_arg0, _arg1, _arg2, _arg3);
          reply.writeNoException();
          reply.writeInt(_result);
          return true;
        }
        case TRANSACTION_setStatusBarDropDownMode:
        {
          data.enforceInterface(descriptor);
          int _arg0;
          _arg0 = data.readInt();
          int _result = this.setStatusBarDropDownMode(_arg0);
          reply.writeNoException();
          reply.writeInt(_result);
          return true;
        }
        case TRANSACTION_setNavigationBarVisibility:
        {
          data.enforceInterface(descriptor);
          int _arg0;
          _arg0 = data.readInt();
          int _result = this.setNavigationBarVisibility(_arg0);
          reply.writeNoException();
          reply.writeInt(_result);
          return true;
        }
        case TRANSACTION_setHideNavigationBarItems:
        {
          data.enforceInterface(descriptor);
          int _arg0;
          _arg0 = data.readInt();
          int _result = this.setHideNavigationBarItems(_arg0);
          reply.writeNoException();
          reply.writeInt(_result);
          return true;
        }
        case TRANSACTION_sysPowerManage:
        {
          data.enforceInterface(descriptor);
          int _arg0;
          _arg0 = data.readInt();
          int _result = this.sysPowerManage(_arg0);
          reply.writeNoException();
          reply.writeInt(_result);
          return true;
        }
        default:
        {
          return super.onTransact(code, data, reply, flags);
        }
      }
    }
    private static class Proxy implements com.sunmi.pay.hardware.aidlv2.system.BasicOptV2
    {
      private android.os.IBinder mRemote;
      Proxy(android.os.IBinder remote)
      {
        mRemote = remote;
      }
      @Override public android.os.IBinder asBinder()
      {
        return mRemote;
      }
      public java.lang.String getInterfaceDescriptor()
      {
        return DESCRIPTOR;
      }
      /**
           * 获取系统参数
           * 功能>通过用户参数关键字，读取系统资源关键字的属性
           * @param key：用户参数关键字,含义如下：
           * <li>“SDKVer”-SDK版本查询</li>
           * <li>“HardwareVer”-设备硬件版本</li>
           * <li>“FirmwareVer”-设备固件版本</li>
           * <li>“SN”-获取机器SN号</li>
           * <li>“PN”-获取机器SN1(PN)渠道自定义SN号</li>
           * <li>“TUSN”-获取机器银联TUSN号</li>
           * <li>“DeviceCode”-获取设备型号</li>
           * <li>“DeviceModel”-获取机型</li>
           * @return 所查询的属性值
           */
      @Override public java.lang.String getSysParam(java.lang.String key) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        java.lang.String _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeString(key);
          boolean _status = mRemote.transact(Stub.TRANSACTION_getSysParam, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().getSysParam(key);
          }
          _reply.readException();
          _result = _reply.readString();
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      /**
           * 设置系统参数
           * 功能>写入资源窗口关键字的属性
           * @param key：用户参数关键字
           * @param value：关键字属性值
           * @return 0-成功,非0-错误码
           */
      @Override public int setSysParam(java.lang.String key, java.lang.String value) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        int _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeString(key);
          _data.writeString(value);
          boolean _status = mRemote.transact(Stub.TRANSACTION_setSysParam, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().setSysParam(key, value);
          }
          _reply.readException();
          _result = _reply.readInt();
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      /**
           * 蜂鸣器
           * 功能>控制设备上的蜂鸣器响
           * @param count 连续鸣响的次数(0~100)
           * @param freq  鸣响频率（单位:HZ）
           * @param duration 鸣响的时长（单位：ms）
           * @param interval 两次鸣响的时间间隔（单位：ms,0~10000）
           * @return 0-成功，非0-错误码
           */
      @Override public void buzzerOnDevice(int count, int freq, int duration, int interval) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeInt(count);
          _data.writeInt(freq);
          _data.writeInt(duration);
          _data.writeInt(interval);
          boolean _status = mRemote.transact(Stub.TRANSACTION_buzzerOnDevice, _data, null, android.os.IBinder.FLAG_ONEWAY);
          if (!_status && getDefaultImpl() != null) {
            getDefaultImpl().buzzerOnDevice(count, freq, duration, interval);
            return;
          }
        }
        finally {
          _data.recycle();
        }
      }
      /**
           * LED灯控制
           * 功能>设备上的LED灯状态
           * @param ledIndex: 设备上的LED索引，1~4；1-红，2-绿，3-黄，4-蓝
           * @param ledStatus：LED状态，1表示LED灭，0表示LED亮
           * @return 0-成功，非0-错误码
           */
      @Override public int ledStatusOnDevice(int ledIndex, int ledStatus) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        int _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeInt(ledIndex);
          _data.writeInt(ledStatus);
          boolean _status = mRemote.transact(Stub.TRANSACTION_ledStatusOnDevice, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().ledStatusOnDevice(ledIndex, ledStatus);
          }
          _reply.readException();
          _result = _reply.readInt();
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      /**
           * 设置屏幕独占
           * 功能>设置屏幕独占 禁用底部导航栏和SystemUI下拉框、保持屏幕高亮，不锁屏、禁用音量键
           * @param mode：设置屏幕独占的模式，1：设置屏幕独占，-1设置取消屏幕独占
           * @return 0-成功，非0-错误码
           */
      @Override public int setScreenMode(int mode) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        int _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeInt(mode);
          boolean _status = mRemote.transact(Stub.TRANSACTION_setScreenMode, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().setScreenMode(mode);
          }
          _reply.readException();
          _result = _reply.readInt();
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      /**
           * 获取随机数
           * 功能>获取随机数
           * @param randData：随机数
           * @param len：要获取的随机数长度
           * @return 0-成功，非0-错误码
           */
      @Override public int sysGetRandom(byte[] randData, int len) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        int _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeByteArray(randData);
          _data.writeInt(len);
          boolean _status = mRemote.transact(Stub.TRANSACTION_sysGetRandom, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().sysGetRandom(randData, len);
          }
          _reply.readException();
          _result = _reply.readInt();
          _reply.readByteArray(randData);
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      /**
           * 扩展版LED灯控制
           * @param redStatus 红灯状态,0-亮，1-灭
           * @param greenStatus 绿灯状态,0-亮，1-灭
           * @param yellowStatus 黄灯状态,0-亮，1-灭
           * @param blueStatus 蓝灯状态,0-亮，1-灭
           * @return 0-成功，非0-错误码
           */
      @Override public int ledStatusOnDeviceEx(int redStatus, int greenStatus, int yellowStatus, int blueStatus) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        int _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeInt(redStatus);
          _data.writeInt(greenStatus);
          _data.writeInt(yellowStatus);
          _data.writeInt(blueStatus);
          boolean _status = mRemote.transact(Stub.TRANSACTION_ledStatusOnDeviceEx, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().ledStatusOnDeviceEx(redStatus, greenStatus, yellowStatus, blueStatus);
          }
          _reply.readException();
          _result = _reply.readInt();
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      /**
           * 设置状态栏下拉模式
           * @param mode 状态栏下拉模式，0-启用下拉，1-禁用下拉
           * @return 0-成功，非0-错误码
           */
      @Override public int setStatusBarDropDownMode(int mode) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        int _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeInt(mode);
          boolean _status = mRemote.transact(Stub.TRANSACTION_setStatusBarDropDownMode, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().setStatusBarDropDownMode(mode);
          }
          _reply.readException();
          _result = _reply.readInt();
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      /**
           * 设置导航栏可见性
           * @param visibility 导航栏可见性，0-隐藏，1-显示
           * @return 0-成功，非0-错误码
           */
      @Override public int setNavigationBarVisibility(int visibility) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        int _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeInt(visibility);
          boolean _status = mRemote.transact(Stub.TRANSACTION_setNavigationBarVisibility, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().setNavigationBarVisibility(visibility);
          }
          _reply.readException();
          _result = _reply.readInt();
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      /**
           * 设置隐藏导航栏图标
           * STATUS_BAR_DISABLE_HOME = 0x00200000;//隐藏home键
           * STATUS_BAR_DISABLE_BACK = 0x00400000;//隐藏返回键
           * STATUS_BAR_DISABLE_RECENT = 0x01000000;//隐藏recent键
           * @param mode：隐藏标志，STATUS_BAR_DISABLE_HOME | STATUS_BAR_DISABLE_BACK 可同时隐藏home键和返回键
           * @return 0-成功，非0-错误码
           */
      @Override public int setHideNavigationBarItems(int flag) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        int _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeInt(flag);
          boolean _status = mRemote.transact(Stub.TRANSACTION_setHideNavigationBarItems, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().setHideNavigationBarItems(flag);
          }
          _reply.readException();
          _result = _reply.readInt();
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      /**
           * 电源管理
           * @param mode 模式，1-休眠(不支持)，2-关机，3-重启
           * @return 0-成功，非0-错误码
           */
      @Override public int sysPowerManage(int mode) throws android.os.RemoteException
      {
        android.os.Parcel _data = android.os.Parcel.obtain();
        android.os.Parcel _reply = android.os.Parcel.obtain();
        int _result;
        try {
          _data.writeInterfaceToken(DESCRIPTOR);
          _data.writeInt(mode);
          boolean _status = mRemote.transact(Stub.TRANSACTION_sysPowerManage, _data, _reply, 0);
          if (!_status && getDefaultImpl() != null) {
            return getDefaultImpl().sysPowerManage(mode);
          }
          _reply.readException();
          _result = _reply.readInt();
        }
        finally {
          _reply.recycle();
          _data.recycle();
        }
        return _result;
      }
      public static com.sunmi.pay.hardware.aidlv2.system.BasicOptV2 sDefaultImpl;
    }
    static final int TRANSACTION_getSysParam = (android.os.IBinder.FIRST_CALL_TRANSACTION + 0);
    static final int TRANSACTION_setSysParam = (android.os.IBinder.FIRST_CALL_TRANSACTION + 1);
    static final int TRANSACTION_buzzerOnDevice = (android.os.IBinder.FIRST_CALL_TRANSACTION + 2);
    static final int TRANSACTION_ledStatusOnDevice = (android.os.IBinder.FIRST_CALL_TRANSACTION + 3);
    static final int TRANSACTION_setScreenMode = (android.os.IBinder.FIRST_CALL_TRANSACTION + 4);
    static final int TRANSACTION_sysGetRandom = (android.os.IBinder.FIRST_CALL_TRANSACTION + 5);
    static final int TRANSACTION_ledStatusOnDeviceEx = (android.os.IBinder.FIRST_CALL_TRANSACTION + 6);
    static final int TRANSACTION_setStatusBarDropDownMode = (android.os.IBinder.FIRST_CALL_TRANSACTION + 7);
    static final int TRANSACTION_setNavigationBarVisibility = (android.os.IBinder.FIRST_CALL_TRANSACTION + 8);
    static final int TRANSACTION_setHideNavigationBarItems = (android.os.IBinder.FIRST_CALL_TRANSACTION + 9);
    static final int TRANSACTION_sysPowerManage = (android.os.IBinder.FIRST_CALL_TRANSACTION + 10);
    public static boolean setDefaultImpl(com.sunmi.pay.hardware.aidlv2.system.BasicOptV2 impl) {
      if (Stub.Proxy.sDefaultImpl == null && impl != null) {
        Stub.Proxy.sDefaultImpl = impl;
        return true;
      }
      return false;
    }
    public static com.sunmi.pay.hardware.aidlv2.system.BasicOptV2 getDefaultImpl() {
      return Stub.Proxy.sDefaultImpl;
    }
  }
  /**
       * 获取系统参数
       * 功能>通过用户参数关键字，读取系统资源关键字的属性
       * @param key：用户参数关键字,含义如下：
       * <li>“SDKVer”-SDK版本查询</li>
       * <li>“HardwareVer”-设备硬件版本</li>
       * <li>“FirmwareVer”-设备固件版本</li>
       * <li>“SN”-获取机器SN号</li>
       * <li>“PN”-获取机器SN1(PN)渠道自定义SN号</li>
       * <li>“TUSN”-获取机器银联TUSN号</li>
       * <li>“DeviceCode”-获取设备型号</li>
       * <li>“DeviceModel”-获取机型</li>
       * @return 所查询的属性值
       */
  public java.lang.String getSysParam(java.lang.String key) throws android.os.RemoteException;
  /**
       * 设置系统参数
       * 功能>写入资源窗口关键字的属性
       * @param key：用户参数关键字
       * @param value：关键字属性值
       * @return 0-成功,非0-错误码
       */
  public int setSysParam(java.lang.String key, java.lang.String value) throws android.os.RemoteException;
  /**
       * 蜂鸣器
       * 功能>控制设备上的蜂鸣器响
       * @param count 连续鸣响的次数(0~100)
       * @param freq  鸣响频率（单位:HZ）
       * @param duration 鸣响的时长（单位：ms）
       * @param interval 两次鸣响的时间间隔（单位：ms,0~10000）
       * @return 0-成功，非0-错误码
       */
  public void buzzerOnDevice(int count, int freq, int duration, int interval) throws android.os.RemoteException;
  /**
       * LED灯控制
       * 功能>设备上的LED灯状态
       * @param ledIndex: 设备上的LED索引，1~4；1-红，2-绿，3-黄，4-蓝
       * @param ledStatus：LED状态，1表示LED灭，0表示LED亮
       * @return 0-成功，非0-错误码
       */
  public int ledStatusOnDevice(int ledIndex, int ledStatus) throws android.os.RemoteException;
  /**
       * 设置屏幕独占
       * 功能>设置屏幕独占 禁用底部导航栏和SystemUI下拉框、保持屏幕高亮，不锁屏、禁用音量键
       * @param mode：设置屏幕独占的模式，1：设置屏幕独占，-1设置取消屏幕独占
       * @return 0-成功，非0-错误码
       */
  public int setScreenMode(int mode) throws android.os.RemoteException;
  /**
       * 获取随机数
       * 功能>获取随机数
       * @param randData：随机数
       * @param len：要获取的随机数长度
       * @return 0-成功，非0-错误码
       */
  public int sysGetRandom(byte[] randData, int len) throws android.os.RemoteException;
  /**
       * 扩展版LED灯控制
       * @param redStatus 红灯状态,0-亮，1-灭
       * @param greenStatus 绿灯状态,0-亮，1-灭
       * @param yellowStatus 黄灯状态,0-亮，1-灭
       * @param blueStatus 蓝灯状态,0-亮，1-灭
       * @return 0-成功，非0-错误码
       */
  public int ledStatusOnDeviceEx(int redStatus, int greenStatus, int yellowStatus, int blueStatus) throws android.os.RemoteException;
  /**
       * 设置状态栏下拉模式
       * @param mode 状态栏下拉模式，0-启用下拉，1-禁用下拉
       * @return 0-成功，非0-错误码
       */
  public int setStatusBarDropDownMode(int mode) throws android.os.RemoteException;
  /**
       * 设置导航栏可见性
       * @param visibility 导航栏可见性，0-隐藏，1-显示
       * @return 0-成功，非0-错误码
       */
  public int setNavigationBarVisibility(int visibility) throws android.os.RemoteException;
  /**
       * 设置隐藏导航栏图标
       * STATUS_BAR_DISABLE_HOME = 0x00200000;//隐藏home键
       * STATUS_BAR_DISABLE_BACK = 0x00400000;//隐藏返回键
       * STATUS_BAR_DISABLE_RECENT = 0x01000000;//隐藏recent键
       * @param mode：隐藏标志，STATUS_BAR_DISABLE_HOME | STATUS_BAR_DISABLE_BACK 可同时隐藏home键和返回键
       * @return 0-成功，非0-错误码
       */
  public int setHideNavigationBarItems(int flag) throws android.os.RemoteException;
  /**
       * 电源管理
       * @param mode 模式，1-休眠(不支持)，2-关机，3-重启
       * @return 0-成功，非0-错误码
       */
  public int sysPowerManage(int mode) throws android.os.RemoteException;
}
